
SCROLLINIT
         ld   (PRNTLINE+1),hl
         ld   hl,CLEAR
         ld   de,CLEAR+1
         ld   bc,12*8*16-1
         ld   (hl),0
         ldir 
         ld   hl,BUFFER
         ld   de,BUFFER+1
ROLPAR1  ld   bc,20*12*16-1
         ld   (hl),0
         ldir 

         ld   hl,BUFFER+1
         ld   (GFXADD),hl
         ld   (NEXTBUF+1),hl
         xor  a
         ld   (BITMOVE),a
         ld   (LNCOUNT),a
         
         call PRNTLINE
         
         ld   hl,CLEAR
         ld   (SCROLL+1),hl
         ld   a,(LNCOUNT)
         ld   c,a
         ld   b,12
         ld   (ROLLTMP),bc
         ret
         

PRNTLINE ld   hl,TEXT1
         ld   a,(hl)
         inc  hl
         ld   (PRNTLINE+1),hl
         or   a
         ret  z
         cp   13
         jp   z,NEXTBUF
         
         sub  32
         add  a,a
         ld   l,a
         ld   h,0
         add  hl,hl
         ld   e,l
         ld   d,h
         add  hl,hl
         add  hl,de
         ld   de,FONT+126
         add  hl,de
         srl  a
         ld   e,a
         ld   a,(de)

         ex   af,af'
         
         ld   a,(BITMOVE)
         or   a
         jr   z,NOROL
         
         ex   de,hl
         ld   hl,(GFXADD)
         exx  
         ld   c,a
         ld   b,12
ONECHAR  ld   a,c
         exx  
         ld   c,0
         ld   b,a
         ld   a,(de)
BITMV    srl  a
         rr   c
         djnz BITMV
         ld   (hl),c
         dec  hl
         or   (hl)
         ld   (hl),a
         ld   bc,17
         add  hl,bc
         inc  de
         exx  
         djnz ONECHAR
         
         jr   NEXTCHAR
         
NOROL    
         ex   de,hl
         ld   hl,(GFXADD)
         dec  hl
         ld   bc,16
         
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         add  hl,bc
         inc  de
         ld   a,(de)
         ld   (hl),a
         
NEXTCHAR 
         ld   a,(BITMOVE)
         ld   c,a
         ld   hl,(GFXADD)
         ex   af,af'
         add  a,c
         cp   8
         jr   c,OKMOVE
         sub  8
         inc  hl
OKMOVE   ld   (BITMOVE),a
         ld   (GFXADD),hl
         
         jp   PRNTLINE
         
NEXTBUF  ld   hl,BUFFER+1
         ld   bc,16*12
         add  hl,bc
         ld   (NEXTBUF+1),hl
         ld   (GFXADD),hl
         xor  a
         ld   (BITMOVE),a
         ld   hl,LNCOUNT
         inc  (hl)
         
         jp   PRNTLINE
         

;SCROLL returns CARRY when
;scroll is over

SCROLL
         ld   hl,CLEAR
         exx  
         
         ld   bc,(ROLLTMP)
         djnz ROL1
         ld   b,12
         dec  c
         jr   nz,ROL1
         scf  
         ret  
         
ROL1     exx  
         
ROLPLACE ld   de,18560+16
;         ld   de,16384+16
         ld   a,11*8/4
ROLLVIEW ex   af,af'
         exx
         ld   e,4
ROLLEDIT exx
         
         ld   a,e
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         ldi  
         inc  l
         inc  hl
         ld   e,a
         inc  d
         exx
         dec  e
         jr   nz,ROLLEDIT
         exx

         ld   a,d
         and  7
         jr   nz,DOWNDEN
         ld   a,e
         add  a,32
         ld   e,a
         ld   a,d
         jp   c,DOWNDEN
         sub  8
         ld   d,a
DOWNDEN
         ex   af,af'
         dec  a
         jr   nz,ROLLVIEW
         
         ld   bc,-1392
;-(11*8*16-16)
         add  hl,bc
         ld   (SCROLL+1),hl
         exx  
         ld   (ROLLTMP),bc
         
         or   a
         ret  
         

GFXADD   defw BUFFER+1
BITMOVE  defb 0
LNCOUNT  defb 0
ROLLTMP  defw 0

         defs 256-($%256)
FONT
#include "little.asm"
         
TEXT1    defm "I fall down to "
         defm "the sky"
         defb 13
         defm "without the rea"
         defm "son"
         defb 13
         defm "don't know why"
         defb 13
         defm "closed into pri"
         defm "son"
         defb 13
         defm "lookin' for som"
         defm "e being"
         defb 13
         defm "searching the w"
         defm "ay"
         defb 13
         defm "out of this dyi"
         defm "ng"
         defb 13
         defb 13,13,13,13,13,13
         defb 13,13
         defb 0
         
TEXT2    defb 13
         defm "day has reached"
         defm " the end"
         defb 13
         defm "and i'm closing"
         defm " my eyes"
         defb 13
         defm "flying to the l"
         defm "and"
         defb 13
         defm "i believe into "
         defm "lies"
         defb 13
         defm "they said me as"
         defm " a child"
         defb 13
         defm "with no real se"
         defm "nce"
         defb 13
         defm "for a fight"
         defb 13
         defb 13,13,13,13,13,13
         defb 13,13
         defb 0
         

TEXT3    defm "i have just dre"
         defm "ams"
         defb 13
         defm "in my mind"
         defb 13
         defm "not about means"
         defb 13
         defm "as they lied"
         defb 13
         defm "my body's dying"
         defb 13
         defm "i'm no more sla"
         defm "ve"
         defb 13
         defm "on grass just l"
         defm "ieing"
         defb 13
         defm "freedom death m"
         defm "e gave"
         defb 13
         defb 13,13,13,13,13,13
 ;14  ;43

          defm "This is Pondlife"
          defb 13
          defm "part by ZeroTeam."
          defb 13,13
          defm "We wanna thanx"
          defb 13
          defm "to Gasman for"
          defb 13
          defm "making this demo"
          defb 13
          defm "and to all other"
          defb 13
          defm "people interested"
          defb 13
          defm "in this project."
          defb 13,13
          defm "Greetings to all"
          defb 13
          defm "active Speccy users"
          defb 13
          defm "who keeps me working."
          defb 13,13
          defm "Special greets to:"
          defb 13
          defm "SS BaZe AstEx iCabod"
          defb 13
          defm "LaeSq Justinas p0l"
          defb 13
          defm "hEllboY yeRzmyey"
          defb 13
          defm "RamSoft buSy NoRo"
          defb 13
          defm "and to really all"
          defb 13
          defm "others!"
          defb 13,13
          defm "Some credits:"
          defb 13
          defm "code&design by"
          defb 13
          defm "mike/ZeroTeam"
          defb 13
          defm "add code by"
          defb 13
          defm "SS/ZeroTeam"
          defb 13
          defm "music by"
          defb 13
          defm "Gasman/Raww Arse"
          defb 13
          defm "graphics by"
          defb 13
          defm "Miron Heletej"
          defb 13
          defm "(Bunch Of No Hopers)"
          defb 13,13
          defm "(C) 2001 by ZeroTeam"
          defb 13
          defm "Constellation"
          defb 13,13,13,13,13,13,13,13,13,0


;         defm "This is Pondlife"
;         defb 13
;         defm "part by ZeroTeam"
;         defb 13,13
;         defm "We like to thanx"
;         defb 13
;         defm "all interested"
;         defb 13
;         defm "people in this project"
;         defb 13,13
;         defm "At first we like "
;         defb 13
;         defm "thanx to GASMAN"
;         defb 13
;         defm "for make this"
;         defb 13
;         defm "project"
;         defb 13,13
;         defm "Next to all active"
;         defb 13
;         defm "speccy user witch"
;         defb 13
;         defm "keep me working"
;         defb 13,13
;         defm "Specially greets to:"
;         defb 13
;         defm "SS BaZe AstEx iCabod"
;         defb 13
;         defm "LaeSq Justinas p0l"
;         defb 13
;         defm "hEllboY yeRzmey"
;         defb 13
;         defm "RamSoft buSy NoRo"
;         defb 13,0

         
CLEAR    defs 12*8*16
BUFFER   defs 20*12*16

;         end

