

#include "basics.zh"
#include "pondlife.h"

               call MUSICINIT
               di
               xor  a
               ld   (ZAS+1),sp
               ld   sp,STACK
               ld   (ENDSIGN),a
               ld   hl,IM2TABLE
               ld   de,IM2TABLE+1
               ld   bc,256
               ld   (hl),255
               ldir
               ld   hl,-1
               ld   (hl),24
               ld   hl,65524
               ld   (hl),195
               ld   hl,IM2INTER
               ld   (65525),hl
               ld   a,IM2TABLE/256
               ld   i,a
               im   2

               ld   hl,NOHOPERS1
               ld   de,PICTURE
               call DEHR
               ld   hl,PICTURE
               ld   de,16384
               ld   bc,6912
               ldir

               ld   c,35
_LOCALWAIT     call WAIT
               dec  c
               jr   nz,_LOCALWAIT

               call FADEOFF

               call WAIT

               ld   hl,NOHOPERS2
               ld   de,PICTURE
               call DEHR
               call FADEON

               call WAIT

               ld   hl,18560+16+32
               ld   (ROLPLACE+1),hl
               ld   hl,TEXT1
               call SCROLLINIT
               ld   a,205      ;call ???
               ld   (PART_1),a

               call PLAZMA

               call FADEOFF

               ld   hl,NOHOPERS4
               ld   de,PICTURE
               call DEHR
               call FADEON

               call BARS
               ld   hl,18560
               ld   (ROLPLACE+1),hl
               ld   hl,TEXT2
               call SCROLLINIT
               ld   a,205
               ld   (PART_2),a

               call BARSEFFECT

               call FADEOFF

               ld   hl,NOHOPERS3
               ld   de,PICTURE
               call DEHR
               call FADEON

               ld   hl,22528+384+16
               ld   a,12
BALLSCOLOR     ld   (hl),7
               ld   d,h
               ld   e,l
               inc  e
               ld   bc,15
               ldir
               ld   bc,17
               add  hl,bc
               dec  a
               jr   nz,BALLSCOLOR

               ld   hl,57*12*16-1
               ld   (ROLPAR1+1),hl
               ld   hl,16384+16
               ld   (ROLPLACE+1),hl
               ld   hl,TEXT3
               call SCROLLINIT

               ld   a,205
               ld   (PART_3),a

               call BALLS2

               call FADEOFF

               ld   hl,NOHOPERS1
               ld   de,PICTURE
               call DEHR
               call FADEON

               ld   c,80
W8             call WAIT
               dec  c
               jr   nz,W8

ABSEND         di

               xor  a
               ex   af,af'
               ld   c,$FD
               ld   a,16
SILENT         ld   b,$FF
               out  (c),a
               ld   b,$BF
               ex   af,af'
               out  (c),a
               ex   af,af'
               dec  a
               jr   nz,SILENT

               ld   hl,NOHOPERS1
               ld   de,PICTURE
               call DEHR
               ld   hl,PICTURE
               ld   de,16384
               ld   bc,6912
               ldir
ZAS            ld   sp,0
               ld   a,63
               ld   i,a
               im   1
               ld   hl,10072
               exx
               ei
               ret

IM2INTER       push af
               push hl
               push de
               push bc
               exx
               ex   af,af'
               push af
               push hl
               push de
               push bc
               push ix

               ld   a,127
               in   a,(254)
               rra
               jr   nc,ABSEND

PART_1         ld   hl,PART1

PART_2         ld   hl,PART2

PART_3         ld   hl,PART3

               call MUSICPLAY

               pop  ix
               pop  bc
               pop  de
               pop  hl
               pop  af
               ex   af,af'
               exx
               pop  bc
               pop  de
               pop  hl
               pop  af
               ei
               ret

WAIT           ld   b,10
_WAIT          ei
               halt
               djnz _WAIT
               ret

PART1          ld   a,1
               dec  a
               jr   z,PART1_1
               dec  a
               jr   z,PART1_2
_COUNT1_3      ld   hl,350
               dec  hl
               ld   (_COUNT1_3+1),hl
               ld   a,l
               or   h
               ret  nz
               dec  a
               ld   (ENDSIGN),a
               ld   a,33
               ld   (PART_1),a
               ret
PART1_1        ld   hl,400
               dec  hl
               ld   (PART1_1+1),hl
               ld   a,l
               or   h
               ret  nz
               ld   hl,PART1+1
               inc  (hl)
               ret
PART1_2        ld   a,1
               xor  1
               ld   (PART1_2+1),a
               ret  z
               call SCROLL
               ret  nc
               ld   hl,PART1+1
               inc  (hl)
               ret

PART2          call PART22
               jp   BARSMAIN
PART22         ld   a,1
               dec  a
               jr   z,PART2_1
               dec  a
               jr   z,PART2_2
PART2_3        ld   hl,400
               dec  hl
               ld   (PART2_3+1),hl
               ld   a,h
               or   l
               ret  nz
               dec  a
               ld   (ENDSIGN),a
               ld   a,33
               ld   (PART_2),a
               ret
PART2_1        ld   hl,350
               dec  hl
               ld   (PART2_1+1),hl
               ld   a,l
               or   h
               ret  nz
               ld   hl,PART22+1
               inc  (hl)
               ret
PART2_2        ld   a,1
               xor  1
               ld   (PART2_2+1),a
               ret  z
               call SCROLL
               ret  nc
               ld   hl,PART22+1
               inc  (hl)
               ret

PART3          ld   a,1
               dec  a
               jr   z,PART3_1
               dec  a
               jr   z,PART3_2
PART3_3        ld   hl,500
               dec  hl
               ld   (PART3_3+1),hl
               ld   a,h
               or   l
               ret  nz
               dec  a
               ld   (ENDSIGN),a
               ld   a,33
               ld   (PART_3),a
               ret
PART3_1        ld   hl,375
               dec  hl
               ld   (PART3_1+1),hl
               ld   a,l
               or   h
               ret  nz
               ld   hl,PART3+1
               inc  (hl)
               ret
PART3_2        ld   a,1
               xor  1
               ld   (PART3_2+1),a
               ret  z
               call SCROLL
               ret  nc
               ld   hl,PART3+1
               inc  (hl)
               ret

               defs 100
STACK          defw 0
ENDSIGN        defb 0
               defs 256-($%256)
IM2TABLE       defs 257

               end

